%global momorel 6

%define posix_threads 0
%{?!SDB:    %define SDB         1}
%{?!LIBBIND:%define LIBBIND     1}
%{?!efence: %define efence      0}
%{?!test:   %define test        0}
%{?!WITH_DBUS: %define WITH_DBUS 1} # + dynamic forwarder table management with D-BUS
# Usage: export RPM='/usr/bin/rpmbuild --define "test 1"'; make $arch;
Summary: The Berkeley Internet Name Domain (BIND) DNS (Domain Name System) server.
Name: bind
Version: 9.3.2
Release: %{momorel}m
License: Modified BSD
Url: http://www.isc.org/products/BIND/
Buildroot: %{_tmppath}/%{name}-%{version}-root
Group: System Environment/Daemons
Source: ftp://ftp.isc.org/isc/bind9/%{version}/bind-%{version}.tar.gz
NoSource: 0
#Source1: bind-manpages-2.tar.bz2
# Finally, ISC are distributing man named.conf(5) and nslookup(8) !
Source1: named.sysconfig
Source2: named.init
Source3: named.logrotate
Source4: keygen.c
Source5: rfc1912.txt
Source6: bind-chroot.tar.gz
Source7: bind-9.3.1rc1-sdb_tools-Makefile.in
Source8: dnszone.schema
Source9: libbind-man.tar.gz
Source10: named-dbus.conf
Source11: named.service
Source12: README.sdb_pgsql
Source13: namedSetForwarders
Source14: namedGetForwarders
Source15: filter_requires.sh
# http://www.venaas.no/ldap/bind-sdb/dnszone-schema.txt
Patch:  bind-9.2.0rc3-varrun.patch
Patch1: bind-9.3.2b2-rndckey.patch
Patch2: bind-9.3.1beta2-openssl-suffix.patch
Patch3: bind-posixthreads.patch
Patch4: bind-bsdcompat.patch
Patch5: bind-nonexec.patch
Patch6: bind-9.2.2-nsl.patch
Patch7: bind-9.2.4rc7-pie.patch
Patch8: bind-9.3.0-handle-send-errors.patch
Patch9: bind-9.3.0-missing-dnssec-tools.patch
Patch10: bind-9.3.2b1-PIE.patch
Patch11: bind-9.3.2b2-sdbsrc.patch
Patch12: bind-9.3.1rc1-sdb.patch
Patch13: bind-9.3.1rc1-fix_libbind_includedir.patch
Patch14: libbind-9.3.1rc1-fix_h_errno.patch
Patch15: bind-9.3.2b2-dbus.patch
Patch16: bind-9.3.1-redhat_doc.patch
Patch17: bind-9.3.2b1-fix_sdb_ldap.patch
Patch18: bind-9.3.1-reject_resolv_conf_errors.patch
Patch19: bind-9.3.1-next_server_on_referral.patch
Patch20: bind-9.3.2b2-no_servfail_stops.patch
Patch21: bind-9.3.2b1-fix_sdb_pgsql.patch
Patch22: bind-9.3.1-sdb_dbus.patch
Patch23: bind-9.3.1-dbus_archdep_libdir.patch
Patch24: bind-9.3.1-t_no_default_lookups.patch
Patch25: bind-9.3.1-fix_no_dbus_daemon.patch
Patch26: bind-9.3.1-flush-cache.patch
Patch27: bind-9.3.1-dbus_restart.patch
Patch28: bind-9.3.2rc1-dbus-0.6.patch
PreReq: chkconfig, shadow-utils
Requires(post): textutils, fileutils, sed, grep
Requires: bind-libs = %{version}-%{release}, bind-utils = %{version}-%{release}, glibc  >= 2.2, initscripts
#Requires: kernel >= 2.4
#Requires: glibc  >= 2.3.2-5
%if %{SDB}
%if %{WITH_DBUS}
BuildRequires: openssl-devel gcc dbus-devel glibc-devel >= 2.2.5-26 glibc-kernheaders >= 2.4-7.10 libtool pkgconfig tar postgresql-devel >= 8.1.3-3m
BuildRequires: openldap-devel >= 2.3.11
%else
BuildRequires: openssl-devel gcc glibc-devel >= 2.2.5-26 glibc-kernheaders >= 2.4-7.10 libtool pkgconfig tar postgresql-devel
BuildRequires: openldap-devel >= 2.3.11
%endif
%else
%if %{WITH_DBUS}
BuildRequires: openssl-devel gcc dbus-devel glibc-devel >= 2.2.5-26 glibc-kernheaders >= 2.4-7.10 libtool pkgconfig tar
%else
BuildRequires: openssl-devel gcc glibc-devel >= 2.2.5-26 glibc-kernheaders >= 2.4-7.10 libtool pkgconfig tar
%endif
%endif
# fix bug 176100: do not Require: perl just for namedGetForwarders !
%define __perl_requires %SOURCE15
%define __find_requires %SOURCE15
%define _use_internal_dependency_generator 0

%description
BIND (Berkeley Internet Name Domain) is an implementation of the DNS
(Domain Name System) protocols. BIND includes a DNS server (named),
which resolves host names to IP addresses; a resolver library
(routines for applications to use when interfacing with DNS); and
tools for verifying that the DNS server is operating properly.

%package libs
Summary: Libraries used by various DNS packages
Group: Applications/System

%description libs
Contains libraries used by both the bind server package as well as the utils packages.

%package utils
Summary: Utilities for querying DNS name servers.
Group: Applications/System
Requires: bind-libs = %{version}-%{release}

%description utils
Bind-utils contains a collection of utilities for querying DNS (Domain
Name System) name servers to find out information about Internet
hosts. These tools will provide you with the IP addresses for given
host names, as well as other information about registered domains and
network addresses.

You should install bind-utils if you need to get information from DNS name
servers.

%package devel
Summary: Include files and libraries needed for bind DNS development.
Group: Development/Libraries
Requires: bind-libs = %{version}-%{release}

%description devel
The bind-devel package contains all the include files and the library
required for DNS (Domain Name System) development for BIND versions
9.x.x.

%if %{LIBBIND}

%package libbind-devel
Summary: Include files and library needed to use the BIND resolver library.
Group: Development/Libraries
Requires: bind-libs = %{version}-%{release}

%description libbind-devel
The bind-libbind-devel package contains the libbind BIND resolver library,
compatible with that from ISC BIND 8, and the /usr/include/bind include files
necessary to develop software that uses it.

%endif

%package chroot
Summary: A chrooted tree for the BIND nameserver
Group: System Environment/Daemons
Prefix: /var/named/chroot
Requires: bind = %{version}-%{release}

%description chroot
This package contains a tree of files which can be used as a
chroot(2) jail for the named(8) program from the BIND package.
Based off code from Jan "Yenya" Kasprzak <kas@fi.muni.cz>

%if %{SDB}

%package sdb
Summary: The Berkeley Internet Name Domain (BIND) DNS (Domain Name System) server with database backends.
Group: System Environment/Daemons
Requires: bind-libs = %{version}-%{release}, bind-utils = %{version}-%{release},  glibc  >= 2.2, initscripts

%description sdb
BIND (Berkeley Internet Name Domain) is an implementation of the DNS
(Domain Name System) protocols. BIND includes a DNS server (named),
which resolves host names to IP addresses; a resolver library
(routines for applications to use when interfacing with DNS); and
tools for verifying that the DNS server is operating properly.

BIND SDB (Simplified Database Backend) provides named_sdb, the DNS
name server compiled to include support for using alternative Zone Databases
stored in an LDAP server (ldapdb), a postgreSQL database (pgsqldb), or in the
filesystem (dirdb), in addition  to the standard in-memory RBT (Red Black Tree)

zone database.

%endif

%prep
%setup -q -n %{name}-%{version}
%patch -p1 -b .varrun
%patch1 -p1 -b .key
%patch2 -p1 -b .openssl_suffix
#%if %{posix_threads}
#%patch3 -p1 -b .posixthreads
#%endif
# This patch is no longer required and would not work anyway (see BZ 87525).
%patch4 -p1 -b .bsdcompat
%patch5 -p1 -b .nonexec
%patch6 -p1 -b .nsl
#%patch7 -p1 -b .pie
# This patch now in patch10
#%patch8 -p1 -b .handle_send_errors
# This patch is now in ISC bind-9.3.1x
#
#%patch9 -p1 -b .missing_dnssec_tools
#RIP dnssec-signkey and dnssec-makekeyset:
#1852.  [cleanup]       Remove last vestiges of dnssec-signkey and
#                       dnssec-makekeyset (removed from Makefile years ago).
#
%patch10 -p1 -b .PIE
%if %{SDB}
%patch11 -p1 -b .sdbsrc
# BUILD 'Simplified Database Backend' (SDB) version of named: named_sdb
cp -rfp bin/named bin/named_sdb
# SDB ldap
cp -fp contrib/sdb/ldap/ldapdb.[ch] bin/named_sdb
# SDB postgreSQL
cp -fp contrib/sdb/pgsql/pgsqldb.[ch] bin/named_sdb
# SDB Berkeley DB - needs to be ported to DB4!
#cp -fp contrib/sdb/bdb/bdb.[ch] bin/named_sdb
# SDB dir
cp -fp contrib/sdb/dir/dirdb.[ch] bin/named_sdb
# SDB tools
mkdir -p bin/sdb_tools
cp -fp %{SOURCE7} bin/sdb_tools/Makefile.in
#cp -fp contrib/sdb/bdb/zone2bdb.c bin/sdb_tools
cp -fp contrib/sdb/ldap/{zone2ldap.1,zone2ldap.c} bin/sdb_tools
# use postgresql include file /usr/include/pgsql
perl -pi -e 's,libpq-fe\.h,pgsql/libpq-fe.h,' contrib/sdb/pgsql/zonetodb.c
cp -fp contrib/sdb/pgsql/zonetodb.c bin/sdb_tools
%patch12 -p1 -b .sdb
%endif
%if %{LIBBIND}
%patch13 -p1 -b .fix_libbind_includedir
%patch14 -p1 -b .fix_h_errno
%endif
%if %{WITH_DBUS}
%patch15 -p1 -b .dbus
%if %{SDB}
%patch22 -p1 -b .sdb_dbus
%endif
%patch23 -p1 -b .dbus_archdep_libdir
%else
%patch16 -p1 -b .redhat_doc
%endif
%if %{SDB}
%patch17 -p1 -b .fix_sdb_ldap
%endif
# %patch18 -p1 -b .reject_resolv_conf_errors
# patch now upstream.
%patch19 -p1 -b .next_server_on_referral
%patch20 -p1 -b .no_servfail_stops
# patches now upstream :
#%patch21 -p1 -b .fix_sdb_pgsql
#%patch24 -p1 -b .-t_no_default_lookups
%patch25 -p1 -b .fix_no_dbus_daemon
%patch26 -p1 -b .flush_cache
%patch27 -p1 -b .dbus_restart
%patch28 -p1 -b .dbus-0.6
#
# this must follow all dbus patches:
%if %{WITH_DBUS}
%if %{SDB}
cp -fp bin/named/{dbus_mgr.c,dbus_service.c,log.c,server.c} bin/named_sdb
cp -fp bin/named/include/named/{dbus_mgr.h,dbus_service.h,globals.h,server.h,log.h,types.h} bin/named_sdb/include/named
%endif
%endif

%build
libtoolize --copy --force; aclocal; autoconf
cp -f /usr/share/libtool/config.{guess,sub} .
export CFLAGS="%{optflags}"
%if %{WITH_DBUS}
%ifarch s390x x86_64 ppc64
# every 64-bit arch EXCEPT ia64 has dbus architecture dependant
# includes in  /usr/lib64/dbus-1.0/include
export DBUS_ARCHDEP_LIBDIR=lib64
%endif
%endif
if pkg-config openssl ; then
        export CFLAGS="$CFLAGS `pkg-config --cflags openssl`"
        export CPPFLAGS="$CPPFLAGS `pkg-config --cflags-only-I openssl`"
        export LDFLAGS="$LDFLAGS `pkg-config --libs-only-L openssl`"
fi
#export CFLAGS="-g $CFLAGS"
%if %{efence}
export LDFLAGS=-lefence
%endif
%configure --with-libtool --localstatedir=/var \
        --enable-threads \
        --enable-ipv6 \
        --with-pic \
%if %{LIBBIND}
        --enable-libbind \
%endif
        --with-openssl=/usr
make %{?_smp_mflags}
if [ $? -ne 0 ]; then
   exit $?;
fi;
cp %{SOURCE5} doc/rfc
gzip -9 doc/rfc/*

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/etc/{rc.d/init.d,logrotate.d}
mkdir -p %{buildroot}/usr/{bin,lib,sbin,include}
mkdir -p %{buildroot}/var/named
mkdir -p %{buildroot}/var/named/slaves
mkdir -p %{buildroot}/var/named/data
mkdir -p %{buildroot}%{_mandir}/{man1,man5,man8}
mkdir -p %{buildroot}/var/run/named
#chroot
mkdir -p %{buildroot}/%{prefix}
tar --no-same-owner -zxvf %{SOURCE6} --directory %{buildroot}/%{prefix}
# these are required to prevent them being erased during upgrade of previous
# versions that included them (bug #130121):
touch %{buildroot}/%{prefix}/etc/named.conf
touch %{buildroot}/%{prefix}/etc/rndc.key
touch %{buildroot}/%{prefix}/dev/null
touch %{buildroot}/%{prefix}/dev/random
#end chroot
make DESTDIR=%{buildroot} install
install -c -m 640 bin/rndc/rndc.conf %{buildroot}%{_sysconfdir}
install -c -m 755 contrib/named-bootconf/named-bootconf.sh %{buildroot}/usr/sbin/named-bootconf
mkdir -p %{buildroot}%{_initscriptdir}
install -c -m 755 %SOURCE2 %{buildroot}%{_initscriptdir}/named
install -c -m 644 %SOURCE3 %{buildroot}/etc/logrotate.d/named
touch %{buildroot}%{_sysconfdir}/rndc.key
cat << __EOF > %{buildroot}%{_sysconfdir}/rndc.key
key "rndckey" {
        algorithm       hmac-md5;
        secret "@KEY@";
};
__EOF
%{__cc} %{optflags} -o %{buildroot}/usr/sbin/dns-keygen %{SOURCE4}
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
cp %{SOURCE1} %{buildroot}%{_sysconfdir}/sysconfig/named
#mv %{buildroot}/usr/share/man/man8/named.conf.* %{buildroot}/usr/share/man/man5
%if %{SDB}
mkdir -p %{buildroot}/etc/openldap/schema
install -c -m 644 %{SOURCE8} %{buildroot}/etc/openldap/schema/dnszone.schema
cp -fp %{SOURCE12} contrib/sdb/pgsql/
%endif
%if %{LIBBIND}
gunzip < %{SOURCE9} | (cd %{buildroot}/usr/share; tar -xpf -)
%endif
%if %{WITH_DBUS}
mkdir -p %{buildroot}/etc/dbus-1/system.d
mkdir -p %{buildroot}/usr/share/dbus-1/services
cp -fp %{SOURCE10} %{buildroot}/etc/dbus-1/system.d/named.conf
cp -fp %{SOURCE11} %{buildroot}/usr/share/dbus-1/services/named.service
cp -fp %{SOURCE13} %{buildroot}/usr/sbin/namedSetForwarders
cp -fp %{SOURCE14} %{buildroot}/usr/sbin/namedGetForwarders
%endif
%if %{test}
if [ "`whoami`" = 'root' ]; then
   set -e
   chmod -R a+rwX .
   pushd bin/tests
   pushd system
   ./ifconfig.sh up
   popd
   make test
   e=$?
   pushd system
   ./ifconfig.sh down
   popd
   popd
   if [ "$e" -ne 0 ]; then
      echo "ERROR: this build of BIND failed 'make test'. Aborting."
      exit $e;
   fi;
else
   echo 'test==1 : only root can run the tests (they require an ifconfig).';
fi
:;
%endif
# Files required to run test-suite outside of build tree:
cp -fp config.h %{buildroot}/%{_includedir}/bind9
cp -fp lib/dns/include/dns/forward.h %{buildroot}/%{_includedir}/dns
cp -fp lib/isc/unix/include/isc/keyboard.h %{buildroot}/%{_includedir}/isc
cp -fp lib/isc/include/isc/hash.h %{buildroot}/%{_includedir}/isc
# Remove libtool .la files:
find %{buildroot}/%{_libdir} -name '*.la' -exec '/bin/rm' '-f' '{}' ';';
# /usr/lib/rpm/brp-compress
#
:;

%pre
/usr/sbin/groupadd -g 25 named 2>/dev/null || :;
/usr/sbin/useradd -c "Named" -u 25 -g 25 \
	-s /bin/false -r -d /var/named named 2>/dev/null || :;

%post
if [ "$1" -eq 1 ]; then
        /sbin/chkconfig --add named
        if [ -f /etc/named.boot -a ! -f /etc/named.conf ]; then
          if [ -x /usr/sbin/named-bootconf ]; then
                cat /etc/named.boot | /usr/sbin/named-bootconf > /etc/named.conf
                chmod 644 /etc/named.conf
          fi
        fi
        if grep -q '@KEY@' /etc/rndc.key; then
          sed -e "s/@KEY@/`/usr/sbin/dns-keygen`/" /etc/rndc.key >/etc/rndc.key.tmp
          mv -f /etc/rndc.key.tmp /etc/rndc.key
        fi
        if [ ! -s /etc/named.conf ]; then
           echo -e '// Default named.conf generated by install of bind-'%{version}'-'%{release}'\noptions {\n\tdirectory "/var/named";\n\tdump-file "/var/named/data/cache_dump.db";\n\tstatistics-file "/var/named/data/named_stats.txt";\n};\ninclude "/etc/rndc.key";\n' > /etc/named.conf;
        fi;
        [ -d /selinux ] && [ -x /sbin/restorecon ] && /sbin/restorecon /etc/rndc.key /etc/rndc.conf /etc/named.conf >/dev/null 2>&1
        chmod 0640 /etc/rndc.conf /etc/rndc.key
        chown root:named /etc/rndc.conf /etc/rndc.key /etc/named.conf
        /sbin/ldconfig
fi
:;

%preun
if [ "$1" = 0 ]; then
#   /usr/sbin/userdel named 2>/dev/null || :;
#   /usr/sbin/groupdel named 2>/dev/null || :;
   /sbin/chkconfig --del named || :;
   if [ -f /var/lock/subsys/named ]; then
     /sbin/service named stop >/dev/null 2>&1 || :;
   fi
fi
:;

%postun
if [ "$1" -ge 1 ]; then
   /sbin/service named condrestart >/dev/null 2>&1 || :
fi;
/sbin/ldconfig
	       
%postun utils
# because bind-utils depends on bind, it gets uninstalled first,
# so bind's preun's 'service named stop' will fail (no rndc).
if [ $1 = 0 ]; then
   if [ -f /var/lock/subsys/named ]; then
      /sbin/service named stop >/dev/null  2>&1 || :;
   fi;
fi;
:;

%triggerpostun -- bind < 8.2.2_P5-15
/sbin/chkconfig --add named
/sbin/ldconfig
:;
%triggerpostun -n bind -- bind <= 24:9.3.1-11
if [ "$1" -gt 0 ]; then
# bind <= 22:9.3.0-2:
# These versions of bind installed named service at order 55 in
# runlevel startup order, after programs like  nis / ntp / nfs
# which may need its services if using no nameservers in resolv.conf.
# bind <= 24:9.3.1-11:
# These versions ran bind with order 11 in runlevel 2, after syslog
# at order 12 . BIND should run after syslog and now has order '- 13 87'.
#
   rl=()
   for l in 0 1 2 3 4 5 6;
   do
        if chkconfig --level=$l named; then
           rl=(${rl[@]} 1)
        else
           rl=(${rl[@]} 0)
        fi
   done
   chkconfig --del named
   chkconfig --add named
   let l=0;
   for s in ${rl[@]};
   do
       if [ "$s" = "1" ]; then
          chkconfig --level=$l named on;
       else
          chkconfig --level=$l named off;
       fi;
       let l='l+1';
   done;
fi
:;

%clean
rm -rf %{buildroot}
# ${RPM_BUILD_DIR}/%{name}-%{version}
:;

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc CHANGES COPYRIGHT README
%doc doc/arm doc/misc
%if %{WITH_DBUS}
%doc doc/README.DBUS
%attr(644,root,root) %config /etc/dbus-1/system.d/named.conf
%attr(644,root,root) %config /usr/share/dbus-1/services/named.service
%attr(754,root,root) /usr/sbin/namedGetForwarders
%attr(754,root,root) /usr/sbin/namedSetForwarders
%endif
%config(noreplace) /etc/logrotate.d/named
%attr(754,root,root) %config %{_initscriptdir}/named
%config(noreplace) /etc/sysconfig/named
%verify(not size,not md5) %config(noreplace) %attr(0640,root,named) /etc/rndc.conf
%verify(not size,not md5) %config(noreplace) %attr(0640,root,named) /etc/rndc.key

%{_sbindir}/dnssec*
%{_sbindir}/lwresd
%{_sbindir}/named
%{_sbindir}/named-bootconf
%{_sbindir}/named-check*
%{_sbindir}/rndc*
%{_sbindir}/dns-keygen

%{_mandir}/man5/named.conf.5*
%{_mandir}/man5/rndc.conf.5*
%{_mandir}/man8/rndc.8*
%{_mandir}/man8/named.8*
%{_mandir}/man8/lwresd.8*
%{_mandir}/man8/dnssec*.8*
%{_mandir}/man8/named-checkconf.8*
%{_mandir}/man8/named-checkzone.8*
%{_mandir}/man8/rndc-confgen.8*

%attr(750,root,named) %dir /var/named
%attr(770,named,named) %dir /var/named/slaves
%attr(770,named,named) %dir /var/named/data
%attr(770,named,named) %dir /var/run/named

%files libs
%defattr(-,root,root)
%{_libdir}/*.so.*

%files utils
%defattr(-,root,root)
%{_bindir}/dig
%{_bindir}/host
%{_bindir}/nslookup
%{_bindir}/nsupdate
%{_mandir}/man1/host.1*
%{_mandir}/man8/nsupdate.8*
%{_mandir}/man1/dig.1*
%{_mandir}/man1/nslookup.1*

%files devel
%defattr(-,root,root)
%{_libdir}/libbind9.a
%{_libdir}/libbind9.so
%{_libdir}/libdns.a
%{_libdir}/libdns.so
%{_libdir}/libisc.a
%{_libdir}/libisc.so
%{_libdir}/libisccc.a
%{_libdir}/libisccc.so
%{_libdir}/libisccfg.a
%{_libdir}/libisccfg.so
%{_libdir}/liblwres.a
%{_libdir}/liblwres.so
%{_includedir}/bind9
%{_includedir}/dns
%{_includedir}/dst
%{_includedir}/isc
%{_includedir}/isccc
%{_includedir}/isccfg
%{_includedir}/lwres
%{_mandir}/man3/lwres*
%{_bindir}/isc-config.sh
%doc doc/draft doc/rfc

%if %{LIBBIND}

%files libbind-devel
%defattr(-,root,root)
%{_libdir}/libbind.a
%{_libdir}/libbind.so

%{_includedir}/bind
%{_mandir}/man3/libbind-*
%{_mandir}/man7/libbind-*
%{_mandir}/man5/libbind-*

%post libbind-devel -p /sbin/ldconfig

%postun libbind-devel -p /sbin/ldconfig

%endif

%files chroot
%defattr(-,root,root)
%attr(750,root,named) %dir %prefix
%attr(750,root,named) %dir %prefix/dev
%attr(750,root,named) %dir %prefix/etc
%attr(750,root,named) %dir %prefix/var
%attr(770,root,named) %dir  %prefix/var/run
%attr(770,named,named) %dir %prefix/var/tmp
%attr(770,named,named) %dir %prefix/var/run/named
%attr(750,root,named) %dir  %prefix/var/named
%attr(770,named,named) %dir %prefix/var/named/slaves
%attr(770,named,named) %dir %prefix/var/named/data
%ghost %prefix/etc/named.conf
%ghost %prefix/etc/rndc.key
%ghost %prefix/dev/null
%ghost %prefix/dev/random

%if %{SDB}

%files sdb
%defattr(-,root,named)
%{_sbindir}/named_sdb
%config /etc/openldap/schema/dnszone.schema
%{_sbindir}/zone2ldap
%{_sbindir}/ldap2zone
%{_sbindir}/zonetodb
%{_mandir}/man1/zone2ldap.1*
%doc contrib/sdb/ldap/README.ldap contrib/sdb/ldap/INSTALL.ldap contrib/sdb/pgsql/README.sdb_pgsql

%post sdb
if [ "$1" -ge 1 ]; then
   # check that dnszone.schema is installed in OpenLDAP's slapd.conf
   if [ -x /usr/sbin/named_sdb ] && [ -f /etc/openldap/slapd.conf ]; then
   # include the LDAP dnszone.schema in slapd.conf:
      if ! /bin/egrep -q '^include.*\dnszone.schema' /etc/openldap/slapd.conf; then
         tf=`/bin/mktemp /tmp/XXXXXX`
         let n=`/bin/grep -n '^include.*\.schema' /etc/openldap/slapd.conf | /usr/bin/tail -1 | /bin/sed 's/:.*//'`
         if [ "$n" -gt 0 ]; then
            /bin/cp -fp /etc/openldap/slapd.conf /etc/openldap/slapd.conf.rpmsave;
            /usr/bin/head -$n /etc/openldap/slapd.conf > $tf
            echo 'include         /etc/openldap/schema/dnszone.schema' >> $tf
            let n='n+1'
            /usr/bin/tail -n +$n /etc/openldap/slapd.conf >> $tf
            /bin/mv -f $tf /etc/openldap/slapd.conf;
            /bin/chmod --reference=/etc/openldap/slapd.conf.rpmsave /etc/openldap/slapd.conf
            [ -d /selinux ] && [ -x /sbin/restorecon ] && /sbin/restorecon /etc/openldap/slapd.conf >/dev/null 2>&1
            [ -x /etc/init.d/ldap ] && /etc/init.d/ldap condrestart >/dev/null 2>&1
         fi
         rm -f $tf >/dev/null 2>&1 || :;
      fi;
   fi;
fi;
:;

%preun sdb
if [ "$1" -eq 0 ] && [ -x /usr/sbin/named_sdb ] && [ -f /etc/openldap/slapd.conf ]; then
   if /bin/egrep -q '^include.*\dnszone.schema' /etc/openldap/slapd.conf; then
      tf=`/bin/mktemp /tmp/XXXXXX`
      /bin/egrep -v '^include.*dnszone\.schema' /etc/openldap/slapd.conf > $tf
      /bin/mv -f $tf /etc/openldap/slapd.conf;
      rm -f $tf >/dev/null 2>&1
      [ -d /selinux ] && [ -x /sbin/restorecon ] && /sbin/restorecon /etc/openldap/slapd.conf >/dev/null 2>&1
      [ -x /etc/init.d/ldap ] && /etc/init.d/ldap condrestart >/dev/null 2>&1 || :;
   fi;
fi;
:;

%endif # SDB

%post chroot
safe_replace()
{
   f1=$1;
   f2=$2;
   o=$3;
   g=$4;
   m=$5;
   dc=$6;
   if /usr/bin/test "x" =  "x$f1" -o "x" =  "x$f2" -o "$f1" =  "$f2"; then
      return 1;
   fi;
   if /usr/bin/test -r $f1 -a -s $f1 -a '!' -L $f1; then
      if /usr/bin/test -r $f2 -a -s $f2 -a '!' -L $f2; then
         /bin/mv $f1 $f1'.rpmsave' >/dev/null 2>&1 || :;
         /bin/mv $f2 $f1 > /dev/null 2>&1 || :;
      else
         /bin/rm -f $f2 > /dev/null 2>&1 || :;
      fi;
      /bin/mv $f1 $f2 > /dev/null 2>&1 || :;
      /bin/ln -s $f2 $f1 > /dev/null 2>&1 || :;
   else
      /bin/rm -f $f1 > /dev/null 2>&1 || :;
      if /usr/bin/test -r $f2 -a -s $f2; then
         /bin/ln -s $f2 $f1 > /dev/null 2>&1 || :;
      else
         if /usr/bin/test "x$dc" != "x"; then
            echo  $dc > $f2;
            /bin/ln -s $f2 $f1 > /dev/null 2>&1 || :;
         else
            return 2;
         fi;
      fi;
   fi;
   chown $o':'$g $f2;
   chmod $m $f2;
   return 0;
}
if /usr/bin/test -r /etc/sysconfig/named && /bin/egrep -q '^ROOTDIR=' /etc/sysconfig/named; then
  :;
else
  echo ROOTDIR="%{prefix}" >>/etc/sysconfig/named;
fi
if /usr/bin/test -r /etc/localtime; then
   /bin/cp -fp /etc/localtime "%{prefix}/etc/localtime"
fi
safe_replace /etc/rndc.key "%{prefix}/etc/rndc.key" root named 644 '';
r=$?;
if /usr/bin/test "$r" -eq 2; then
   /bin/rm -f /etc/rndc.key
   echo -e 'key "rndckey" {\nalgorithm       hmac-md5;\nsecret "'`/usr/sbin/dns-keygen`'"\n};' > /etc/rndc.key;
   safe_replace /etc/rndc.key "%{prefix}/etc/rndc.key" root named 644 '';
fi;
default_ndc='include "/etc/rndc.key";'
if [ -f /etc/named.custom ]; then
   default_ndc='include "/etc/rndc.key";\ninclude "/etc/named.custom";'
   safe_replace /etc/named.custom "%{prefix}/etc/named.custom" root named 644 '' || :;
fi
safe_replace /etc/named.conf "%{prefix}/etc/named.conf" root named 644  "$default_ndc"
/usr/bin/find /var/named -xdev -type f | /bin/egrep -v '/var/named/chroot' | while read f;
do
   d=`/usr/bin/dirname $f`;
   if test '!' -d "%{prefix}$d"; then
        mkdir -p "%{prefix}$d";
        chown named:named "%{prefix}$d";
        chmod 655 "%{prefix}$d";
   fi;
   safe_replace $f "%{prefix}$f" named named 644 '' || :;
done
[ ! -e "%{prefix}/dev/random" ] && mknod "%{prefix}/dev/random" c 1 8
[ ! -e "%{prefix}/dev/zero" ] && mknod "%{prefix}/dev/zero" c 1 5
[ ! -e "%{prefix}/dev/null" ] && mknod "%{prefix}/dev/null" c 1 3
chmod a+r "%{prefix}/dev/random" "%{prefix}/dev/null" "%{prefix}/dev/"
chown root:named "%{prefix}/var/named"
chown named:named "%{prefix}/var/named/slaves"
chown named:named "%{prefix}/var/named/data"
/etc/init.d/named condrestart >/dev/null 2>&1 || :;
[ -d /selinux ] && [ -x /sbin/restorecon ] && /sbin/restorecon -e %{prefix}/proc -e %{prefix}/var/run/dbus -R %{prefix} >/dev/null 2>&1
:;

%preun chroot
if [ "$1" = "0" ]; then
        /usr/bin/find /var/named/chroot -xdev -type f | while read f;
        do
          F=`echo $f | sed 's#/var/named/chroot##'`;
          if /usr/bin/test -L $F && test `/usr/bin/readlink $F` = $f; then
             /bin/rm -f $F;
             /bin/mv $f $F;
          fi;
        done
        if test -r /etc/sysconfig/named && grep -q '^ROOTDIR=' /etc/sysconfig/named; then
          named_tmp=`/bin/mktemp /tmp/XXXXXX`
          grep -v '^ROOTDIR='%{prefix} /etc/sysconfig/named > $named_tmp

	  mv -f $named_tmp /etc/sysconfig/named
          [ -d /selinux ] && [ -x /sbin/restorecon ] && /sbin/restorecon /etc/sysconfig/named
        fi
        /etc/init.d/named condrestart >/dev/null 2>&1 || :;
fi
:;

%triggerpostun -n bind-chroot -- bind-chroot
# Fix mess left by bind-chroot-9.2.2's %preun (bug 131803)
if [ "$1" -gt 0 ]; then
   if test -r /etc/sysconfig/named && grep -q '^ROOTDIR=' /etc/sysconfig/named; then
      :;
   else
      echo 'ROOTDIR='%{prefix} >> /etc/sysconfig/named
      /etc/init.d/named condrestart >/dev/null 2>&1 || :;
   fi;
fi;
:;

%changelog
* Wed Jun  7 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (9.3.2-6m)
- revise %%files to avoid conflicting

* Tue May 30 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (9.3.2-5m)
- add user/group named

* Sun Apr  9 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (9.3.2-4m)
- rebuild against openssl-0.9.8a

* Sat Jan 14 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (9.3.2-3m)
- rebuild against openldap-2.3.11

* Wed Jan 11 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (9.3.2-2m)
- remove Requires: /bin/usleep again for mph-get-check
- add Requires: initscripts

* Tue Jan 10 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (9.3.2-1m)
- update to 9.3.2
- sync with fc-devel

* Sat Mar 12 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (9.2.5-1m)
- update to 9.2.5
- correct named.conf.5 is install into man5, now

* Mon Oct 18 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (9.2.4-2m)
- set specopt
- set _ipv6=1

* Thu Sep 23 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (9.2.4-1m)
- update to 9.2.4
- comment out tar xjf %%{SOURCE1}
- comment out %%{_mandir}/man8/nslookup.8*
- comment out %%{_mandir}/man5/resolver.5*
- comment out %%{_mandir}/man5/resolv.conf.5*
- comment out %%{_mandir}/man5/named.conf.5*
- add %%{_mandir}/man1/nslookup.1*
- move named.conf.5 from man8 to man5
- readd %%{_mandir}/man5/named.conf.5*

* Sat Aug 21 2004 Mitsuru Shimamura <smbd@momonga-linux.org>
- (9.2.3-5m)
- correct License tag

* Fri Jul  9 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (9.2.3-4m)
- add BuildRequires: momonga-rpmmacros >= 20040310-6m

* Tue Mar 15 2004 Toru Hoshina <t@momonga-linux.org>
- (9.2.3-3m)
- revised spec for enabling rpm 4.2.

* Sun Oct 26 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (9.2.3-2m)
- move *.so to bind-devel
- add REMOVEME.bind-devel

* Sat Oct 25 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (9.2.3-1m)
- update to 9.2.3

* Sat Oct 11 2003 Kimitake SHIBATA <siva@momonga-linux.org>
- (9.2.2-3m)
- adapt the License: preamble for the Momonga Linux license
  expression unification policy (draft)

* Wed Mar  5 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (9.2.2-2m)
  rebuild against openssl 0.9.7a

* Thu Mar  4 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (9.2.2-1m)
- upgrade 9.2.2

* Sat Oct 26 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (9.2.1-8m)
- use gcc instead of gcc_2_95_3

* Fri Sep 13 2002 Shingo Akagaki <dora@kitty.dnsalias.org>
- (9.2.1-7m)
- remove Requires: /bin/usleep
- add Requires: initscripts

* Sat Aug 17 2002 KOMATSU Shinichiro <koma2@jiro.c.u-tokyo.ac.jp>
- (9.2.1-6m)
- fix resolver buffer overflow (add bind-9.2.1-overflow.patch)
  Ref. http://www.kb.cert.org/vuls/id/803539
       http://rhn.redhat.com/errata/RHSA-2002-133.html

* Sun Jul 20 2002 Motonobu Ichimura <famao@momonga-linux.org>
- (9.2.1-5m)
- Fix a logrotate bug reported by Shunji Tanaka.

* Fri Jun  7 2002 Masahiro Takahata <takahata@kondara.org>
- (9.2.1-4k)
- modified configure option

* Fri Jun  7 2002 Masahiro Takahata <takahata@kondara.org>
- (9.2.1-2k)
- upgrade to bind-9.2.1

* Thu May  9 2002 Toru Hoshina <t@kondara.org>
- (9.1.3-10k)
- rebuild against glibc 2.2.5, sumaso!

* Sat Dec  1 2001 Toru Hoshina <t@kondara.org>
- (9.1.3-8k)
- add rndc.key

* Sun Nov  4 2001 Toru Hoshina <t@kondara.org>
- (9.1.3-6k)
- rebuild against new environment. because gcc 2.95.3 doesn't recognize
  -fno-merge-constants, use gcc_2_95_3 instead of gcc -V 2.95.3.

* Fri Oct 19 2001 Toru Hoshina <t@kondara.org
- (9.1.3-4k)
- avoid conflict with dhcp 3.0, /usr/lib/libomapi.* was removed.

* Wed Jul  4 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (9.1.3-2k)
- update to bind 9.1.3 maintenance release.
- remove bind-9.1.0-ttl.patch (already fixed)

* Fri May 25 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (9.1.2-8k)
- fixed %pre script
- fixed named.init  (status named)
-  thanks to SEKINE Tatsuo.

* Sat May 19 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (9.1.2-6k)
- merge rawhide.
- fix %postun  named "cond-restart" to "condrestart"
- fix using rndc that obsoletes ndc 
- change pid file /var/run/named/pid to /var/run/named/named.pid and
-   /var/run/lwresd/pid to /var/run/named/lwresd.pid
- add rndc.conf and named.conf sample for "rndc"
- obsolete caching-nameserver

* Tue May  8 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (9.1.2-4k)
- add "textutils, fileutils" to Prereq: 

* Sun May  6 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (9.1.2-2k)
- update to bind 9.1.2 (maintenance release)

* Wed Apr 25 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (9.1.1-8k)
- move files /usr/lib/*.so* to bind-utils, and /usr/lib*.a to bind-devel
- bind-devel requires bind, bind requires bind-utils
- fix %postun  named "condrestart" to "cond-restart"
- fix %preun  script error at rpm -e bind
- comment out userdel/groupdel

* Mon Apr 23 2001 Toru Hoshina <t@kondara.org>
- (9.1.1-6k)
- force use gcc-2.95.3
- cancel to down optimize level (9.1.1-4k)

* Mon Apr 23 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (9.1.1-4k)
- Down optimize level (-O6 to -O2) against Mary.
- append --with-libtool --enable-threads

* Sun Apr 22 2001 Motonobu Ichimura <famao@kondara.org>
- (9.1.1-2k)
- up to 9.1.1

* Wed Apr 18 2001 Motonobu Ichimura <famao@kondara.org>
- (9.1.0-14k)
- brush-up spec file
- now all man pages are include.
- move isc-config.sh from utils to devel package
- added --with-openssl option to use system's one

* Tue Apr 17 2001 HOSONO Hidetomo <h@kondara.org>
- (9.1.0-12k)
- add a configure script option: --localstatedir=/var
- add bind.named.pid.patch
- make directories owned named.named: /var/run/{named,lwresd}

* Sat Apr 15 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (9.1.0-10k)
- add shadow-utils to PreReq tag

* Fri Apr 13 2001 Shingo Akagaki <dora@kondara.org>
- /etc/rc.d/init.d -> /etc/init.d

* Mon Mar 26 2001 Toru Hoshina <toru@df-usa.com>
- (9.1.0-7k)
- rebuild against glibc-2.2.2 and add bind.glibc222.time.patch

* Thu Mar 22 2001 Motonobu Ichimura <famao@kondara.org>
- (9.1.0-5k)
- translate /usr/local/bin/perl -> /usr/bin/perl
- yes. another bug is needed to be fixed. (#867)

* Sun Feb 11 2001 Kusunoki Masanori <nori@kondara.org>
- (9.1.0-3k)
- up to 9.1.0

* Sat Feb  3 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (9.00-7k)
- rebuild againt rpm-3.0.5-39k

* Tue Nov 28 2000 Toru Hoshina <toru@df-usa.com>
- use _initscriptdir macro to keep backword compatibility.

* Tue Sep 26 2000 KUSUNOKI Masanori <nori@kondara.org>
- Version up to 9.0.0.

* Fri Aug 11 2000 AYUHANA Tomonori <l@kondara.org>
- (9.0.0rc1-3k)
- add --enable-ipv6 at %configure
- include nslookup

* Tue Jul 29 2000 MATSUDA, Daiki <dyky@df-usa.com>
- (9.0.0rc1-2k)
- fix version suffix for Kondara RPM Guidance

* Tue Jul 18 2000 KUSUNOKI Masanori <nori@kondara.org>
- updated to 9.0.0rc1

* Sun Jul 16 2000 AYUHANA Tomonori <l@kondara.org>
- (8.2.2pl5-19k)
- change dir /etc/init.d/named -> /etc/rc.d/init.d/named
- fix not generate named.conf (named-bootconf.pl is missing)
- change %triggerpostun

* Sat Jul  8 2000 Toru Hoshina <t@kondara.org>
- rebuild against glibc-2.1.90, X-4.0, rpm-3.0.5.

* Fri Jun 30 2000 Trond Eivind Glomsr?<teg@redhat.com>
- fix the init script

* Wed Jun 28 2000 Nalin Dahyabhai <nalin@redhat.com>
- make libbind.a and nslookup.help readable again by setting INSTALL_LIB to ""

* Mon Jun 26 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Fix up the initscript (Bug #13033)
- Fix build with current glibc (Bug #12755)
- /etc/rc.d/init.d -> /etc/init.d
- use %%{_mandir} rather than /usr/share/man

* Mon Jun 19 2000 Bill Nottingham <notting@redhat.com>
- fix conflict with man-pages
- remove compatibilty chkconfig links
- initscript munging

* Wed Jun 14 2000 Nalin Dahyabhai <nalin@redhat.com>
- modify logrotate setup to use PID file
- temporarily disable optimization by unsetting %{optflags} at build-time
- actually bump the release this time

* Sat Jun 10 2000 Takaaaki Tabuchi <tab@kondara.org>
- (8.2.2pl5-2k)
- rewrite spec file by based on Kondara's spec file
- version change P5 to pl5

* Sat Jun 10 2000 Takaaaki Tabuchi <tab@kondara.org>
- merge rawhide 8.2.2_P5-11 (patch{5,6,7})
- make /var/named owned by named.named
- gziped man
- add resolv.conf.5*

* Thu Jun  8 2000 AYUHANA Tomonori <l@kondara.org>
- /var/named - nobody:nobody

* Tue Jun  6 2000 AYUHANA Tomonori <l@kondara.org>
- change running named by root:root -> nobody:nobody

* Sun Jun  4 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- FHS compliance

* Mon Apr 17 2000 Nalin Dahyabhai <nalin@redhat.com>
- clean up restart patch

* Mon Apr 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- provide /var/named (fix for bugs #9847, #10205)
- preserve args when restarted via ndc(8) (bug #10227)
- make resolv.conf(5) a link to resolver(5) (bug #10245)
- fix SYSTYPE bug in all makefiles
- move creation of named user from %%post into %%pre

* Mon Feb 28 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Fix TTL (patch from ISC, Bug #9820)

* Wed Feb 16 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- fix typo in spec (it's %post, without a leading blank) introduced in -6
- change SYSTYPE to linux

* Sat Feb 11 2000 Bill Nottingham <notting@redhat.com>
- pick a standard < 100 uid/gid for named

* Thu Feb 04 2000 Elliot Lee <sopwith@redhat.com>
- Pass named a '-u named' parameter by default, and add/remove user.

* Thu Feb  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- fix host mx bug (Bug #9021)

* Mon Jan 31 2000 Cristian Gafton <gafton@redhat.com>
- rebuild to fix dependencies
- man pages are compressed

* Wed Jan 19 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- It's /usr/bin/killall, not /usr/sbin/killall (Bug #8063)

* Mon Jan 17 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix up location of named-bootconf.pl and make it executable
  (Bug #8028)
- bind-devel requires bind

* Mon Nov 15 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- update to 8.2.2-P5

* Wed Nov 10 1999 Bill Nottingham <notting@redhat.com>
- update to 8.2.2-P3

* Tue Oct 12 1999 Cristian Gafton <gafton@redhat.com>
- add patch to stop a cache only server from complaining about lame servers
  on every request.

* Fri Sep 24 1999 Preston Brown <pbrown@redhat.com>
- use real stop and start in named.init for restart, not ndc restart, it has
  problems when named has changed during a package update... (# 4890)

* Fri Sep 10 1999 Bill Nottingham <notting@redhat.com>
- chkconfig --del in %preun, not %postun

* Mon Aug 16 1999 Bill Nottingham <notting@redhat.com>
- initscript munging

* Mon Jul 26 1999 Bill Nottingham <notting@redhat.com>
- fix installed chkconfig links to match init file

* Sat Jul  3 1999 Jeff Johnson <jbj@redhat.com>
- conflict with new (in man-1.24) man pages (#3876,#3877).

* Tue Jun 29 1999 Bill Nottingham <notting@redhat.com>
- fix named.logrotate (wrong %SOURCE)

* Fri Jun 25 1999 Jeff Johnson <jbj@redhat.com>
- update to 8.2.1.
- add named.logrotate (#3571).
- hack around egcs-1.1.2 -m486 bug (#3413, #3485).
- vet file list.

* Fri Jun 18 1999 Bill Nottingham <notting@redhat.com>
- don't run by default

* Sun May 30 1999 Jeff Johnson <jbj@redhat.com>
- nslookup fixes (#2463).
- missing files (#3152).

* Sat May  1 1999 Stepan Kasal <kasal@math.cas.cz>
- nslookup patched:
  to count numRecords properly
  to fix subsequent calls to ls -d
  to parse "view" and "finger" commands properly
  the view hack updated for bind-8 (using sed)

* Wed Mar 31 1999 Bill Nottingham <notting@redhat.com>
- add ISC patch
- add quick hack to make host not crash
- add more docs

* Fri Mar 26 1999 Cristian Gafton <gafton@redhat.com>
- add probing information in the init file to keep linuxconf happy
- dont strip libbind

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 3)

* Wed Mar 17 1999 Preston Brown <pbrown@redhat.com>
- removed 'done' output at named shutdown.

* Tue Mar 16 1999 Cristian Gafton <gafton@redhat.com>
- version 8.2

* Wed Dec 30 1998 Cristian Gafton <gafton@redhat.com>
- patch to use the __FDS_BITS macro
- build for glibc 2.1

* Wed Sep 23 1998 Jeff Johnson <jbj@redhat.com>
- change named.restart to /usr/sbin/ndc restart

* Sat Sep 19 1998 Jeff Johnson <jbj@redhat.com>
- install man pages correctly.
- change K10named to K45named.

* Wed Aug 12 1998 Jeff Johnson <jbj@redhat.com>
- don't start if /etc/named.conf doesn't exist.

* Sat Aug  8 1998 Jeff Johnson <jbj@redhat.com>
- autmagically create /etc/named.conf from /etc/named.boot in %post
- remove echo in %post

* Wed Jun 10 1998 Jeff Johnson <jbj@redhat.com>
- merge in 5.1 mods

* Sun Apr 12 1998 Manuel J. Galan <manolow@step.es>
- Several essential modifications to build and install correctly.
- Modified 'ndc' to avoid deprecated use of '-'

* Mon Dec 22 1997 Scott Lampert <fortunato@heavymetal.org>
- Used buildroot
- patched bin/named/ns_udp.c to use <libelf/nlist.h> for include
  on Redhat 5.0 instead of <nlist.h>

